// =====================================================================================================================================================================================================
// (c) 2022 Lynn Hansen, KU7Q															                                                                                                               |
// This Source Code Form is subject to the terms of the GNU GENERAL PUBLIC LICENSE, Version 3, 29 June 2007. A copy of this license can be found here: https://choosealicense.com/licenses/gpl-3.0/|
// =====================================================================================================================================================================================================


//This module handles the ISR timer setup and calls

/*
//Used for multiple soft timers from one hardware timer
//called once in Setup to initialize the hardware timer
void TimerHandler(void)
{
	ISR_Timer.run();
}
*/

void Do_Keyer_ISR()
{
	//execute this code every 1 millisecond	
	//ignore if already running or in save routines	
	if (ISRActive || blockISR)
	{
		return;
	}
	ISRActive = true;
	ChkPaddles();
	ChkEncoder();
	if (gRmtMode == MNU_RMT_KEY)
	{
		ChkRmtPTTKey(); //chk for PTT & function btns in ChkRmtFuncBtns() via Loop()
	}	
	Do_SideTone_ISR();	
	ISRActive = false;
	
}

void Do_SideTone_ISR()
{
	static bool toggle = 0;	
	static int vol = 0;
	//override sidetone off if we're in txt edit mode and using keyer to enter chrs
	//no sidetone on pass thru
	if (gKeyDown && (gSideTone || hmiMode == HMI_TXTINPUT) && gKeyType != KEYER_PASSTHRU)
	{ 		
		if (toggle)
		{
			digitalWrite(SIDETONE, HIGH);
		}
		else
		{
			digitalWrite(SIDETONE, LOW);
		}
		toggle = !toggle;
	}
	else
	{
		digitalWrite(SIDETONE, LOW);
	}
}

void ChkRmtPTTKey()
{
	//use ISR and only read digital value so we can get quick response
	//NOTE: Function Keys don't work in this mode
	static int debounce = 0; //use to debouce for 4 mS
	bool key = digitalRead(RMT_BTNS);
	if (!key && gRmtFuncBtn != RMT_FUNC_PTT)
	{
		debounce++;
		if (debounce>4)
		{
			SerialOut("key down", true);
			gRmtFuncBtn = RMT_FUNC_PTT;
			debounce = 0;			
		}
	}
	else if (key)
	{
		gRmtFuncBtn = RMT_FUNC_OFF;
		debounce = 0;
	}
}





/* Up to 16 timers can be running from on ISR_Timer hardware timer
// In SAMD, avoid doing something fancy in ISR, for example complex Serial.print with String() argument
// The pure simple Serial.prints here are just for demonstration and testing. Must be eliminate in working environment
// Or you can get this run-time error / crash
void doingSomething2s()
{
	// Doing something here inside ISR
}

void doingSomething5s()
{
	// Doing something here inside ISR
}

void doingSomething11s()
{
	// Doing something here inside ISR
}

void doingSomething101s()
{
	// Doing something here inside ISR
}
*/
